function [] = B1a_RecodeExogVars(Infile,Outfile);

load(Infile)

% Attach a blockid to each spot in data array;
blocknum  =  reshape(  jj*ones(1,50),size(Y0,1)*size(Y0,2),1); 

% Stack true data into an array;
Y0_data       =  reshape(Y0,size(Y0,1)*size(Y0,2),1);
Y_data(:,1)   =  reshape(Y1,size(Y0,1)*size(Y0,2),1);
Y_data(:,2)   =  reshape(Y2,size(Y0,1)*size(Y0,2),1);
Y_data(:,3)   =  reshape(Y3,size(Y0,1)*size(Y0,2),1);
Y_data(:,4)   =  reshape(Y4,size(Y0,1)*size(Y0,2),1);
Y_data(:,5)   =  reshape(Y5,size(Y0,1)*size(Y0,2),1);

% Flag spots in the vector that refer to actual households (and not, for instance, house #22 on a block with I=21);
households=  reshape(ones(size(Y0,1),1)*(1:50) <= I*ones(1,50),size(Y0,1)*size(Y0,2),1);

% Exogenous explanatory variables for OLS models
%lnrelwage2= log(w1./w0);
%lnlosses_unins_imp= log(.001 + k - ins);
%black_lnlosses_unins_imp  = majblack .* lnlosses_unins_imp;
%lnhhinc_prek_imp  = lnHHINC05;
lnhomevalue05 = lnHOMEVAL05;

RUNNING = running_imp;
RUNNING1  = max(0, RUNNING-.0);
RUNNING2  = max(0, RUNNING-.3);
RUNNING3  = max(0, RUNNING-.4);
RUNNING4  = max(0, RUNNING-.5);
RUNNING5  = max(0, RUNNING-.6);
RUNNING6  = max(0, RUNNING-.7);
RUNNING7  = max(0, RUNNING-.8);

RISKCAT1 =                   (riskscore<575);
RISKCAT2 = (riskscore>575) & (riskscore<600);
RISKCAT3 = (riskscore>600) & (riskscore<625);
RISKCAT4 = (riskscore>625) & (riskscore<650);
RISKCAT5 = (riskscore>650) & (riskscore<675);
RISKCAT6 = (riskscore>675) & (riskscore<700);
RISKCAT7 = (riskscore>700) & (riskscore<725);
RISKCAT8 = (riskscore>725)                  ;


% Exogenous explanatory variables for RD models
% relevant vars: w0, w1, RENT, PaymentsLeft, Mpmt, Mbal, A0, ins, grant1, grant2
XX1              =   (RUNNING - .51)   ;
XX2              =   (RUNNING - .51).^2;
XXD0             =   (RUNNING>= .51)   ;
XXD1             = XXD0.*(RUNNING - .51)   ;
XXD2             = XXD0.*(RUNNING - .51).^2;
Y5_4RD           =  Y_data(:,5) ;
MU5_loo_4RD      =  reshape((sum(Y5,2)*ones(1,50) - Y5)./((I-1)*ones(1,50)),size(Y0,1)*size(Y0,2),1);
covariates_rd    = [reshape(ones(size(XX1))  ,size(Y0,1)*size(Y0,2),1)  ...
                    reshape(XX1  ,size(Y0,1)*size(Y0,2),1)  ...
                    reshape(XX2  ,size(Y0,1)*size(Y0,2),1)  ...
                    reshape(XXD0 ,size(Y0,1)*size(Y0,2),1)  ...
                    reshape(XXD1 ,size(Y0,1)*size(Y0,2),1)  ...
                    reshape(XXD2 ,size(Y0,1)*size(Y0,2),1)  ];
drop_4RD         =  reshape((Y0==1)|(NEVATRISK_opt2==1)|(RUNNING<.33)|(RUNNING>.67),size(Y0,1)*size(Y0,2),1) + (households==0) > 0;
MU5_loo_4RD(drop_4RD,:)      = [];
Y5_4RD(drop_4RD,:)           = [];
covariates_rd(drop_4RD,:)    = [];


Y5_4closeRD         =  Y_data(:,5) ;
covariates_close_rd = [reshape(ones(size(XX1))  ,size(Y0,1)*size(Y0,2),1)  ...
                       reshape(XX1  ,size(Y0,1)*size(Y0,2),1)  ...
                       reshape(XXD0 ,size(Y0,1)*size(Y0,2),1)  ...
                       reshape(XXD1 ,size(Y0,1)*size(Y0,2),1) ];
drop_4closeRD       =  reshape((Y0==1)|(NEVATRISK_opt2==1)|(RUNNING<.46)|(RUNNING>.56),size(Y0,1)*size(Y0,2),1) + (households==0) > 0;
covariates_close_rd(drop_4closeRD,:) = [];
Y5_4closeRD(drop_4closeRD,:)         = [];

%{
covariates = [reshape(ones(size(floodcat1)),size(Y0,1)*size(Y0,2),1)  ...
              reshape(floodcat1,size(Y0,1)*size(Y0,2),1)  ...
              reshape(floodcat3,size(Y0,1)*size(Y0,2),1)  ...
              reshape(floodcat4,size(Y0,1)*size(Y0,2),1)  ...
              reshape(floodcat5,size(Y0,1)*size(Y0,2),1)  ...
              reshape(floodcat6,size(Y0,1)*size(Y0,2),1)  ...
              reshape(lnhomevalue05,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RUNNING1 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RUNNING2 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RUNNING3 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RUNNING4 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RUNNING5 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RUNNING6 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RUNNING7 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RISKCAT1 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RISKCAT2 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RISKCAT3 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RISKCAT4 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RISKCAT6 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RISKCAT7 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RISKCAT8 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(majblack ,size(Y0,1)*size(Y0,2),1)  ];
%}

covariates = [reshape(ones(size(floodcat1)),size(Y0,1)*size(Y0,2),1)  ...
              reshape(floodcat1,size(Y0,1)*size(Y0,2),1)  ...
              reshape(floodcat3,size(Y0,1)*size(Y0,2),1)  ...
              reshape(floodcat4,size(Y0,1)*size(Y0,2),1)  ...
              reshape(floodcat5,size(Y0,1)*size(Y0,2),1)  ...
              reshape(floodcat6,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RISKCAT1 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RISKCAT2 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RISKCAT3 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RISKCAT4 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RISKCAT6 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RISKCAT7 ,size(Y0,1)*size(Y0,2),1)  ...
              reshape(RISKCAT8 ,size(Y0,1)*size(Y0,2),1)  ];

% Flag observations to be dropped from data-based auxiliary models;
drop_nondamaged=1;
if drop_nondamaged==1;
    drop   =  (  (households==0) + ...
                 (Y0_data   ==1) > 0  );
else;
    drop   =  (  (households==0) > 0  );
end;

%sum(sum( (households==1) .* (drop==0) ))

% Apply sample restrictions;
Y0_data(drop,:)        = [];
Y_data(drop,:)         = [];
blocknum( drop,:)      = [];
covariates(drop,:)     = [];

% Combine covariates and fixed effects;
X_data_rd       = [covariates_rd      ];
X_data_close_rd = [covariates_close_rd];
X_data          = [covariates         ];

save(Outfile);



