function [MU_STAR,Y_model_4OLS,MU5_loo_model_4RD,Y5_model_4RD,SimOutput,Unobservables,VC_NC_STAR,VC_STAR] = B2b_SimulateChoices(I,theta0,theta_spill,beta,replications,V_C_NC_all,V_C_all,e0,e1,u2,tweek_sigma,tweek_rho, Y0,majblack,majcoll,floodcat1,floodcat2,floodcat3,floodcat4,floodcat5,floodcat6,riskscore,NEVATRISK_opt2,RUNNING,cf_policy)


%%%%%%%%%%%%%%%%%%%%%%%%%
%%% 2. simulate model %%%
%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%      (     j      ,  i , t )
Y_model_array = zeros( size(e0,1) , 50 , 5 );

% parameter values -- used for initial simulations;
G_0                 =  exp( theta0(10) ) * exp( theta0( 1) );
M_0                 =                    ( exp(-theta0( 2)) + 1 )^(-1);
V_0                 =                      exp( theta0( 3) );
delta1_0            =  exp( theta0(10) ) *      theta0( 4)  ;
delta2_0            =  exp( theta0(10) ) *      theta0( 5)  ;
delta3_0            =  exp( theta0(10) ) *      theta0( 6)  ;
delta4_0            =  exp( theta0(10) ) *      theta0( 7)  ;
delta5_0            =  exp( theta0(10) ) *      theta0( 8)  ;
sigmab_0            =  exp( theta0(10) ) * exp( theta0( 9) );
sigmaeta_0          =  exp( theta0(10) );
gamma_floodcat1_0   =  exp( theta0(10) ) *      theta0(11);
gamma_floodcat3_0   =  exp( theta0(10) ) *      theta0(12);
gamma_floodcat4_0   =  exp( theta0(10) ) *      theta0(13);
gamma_floodcat5_0   =  exp( theta0(10) ) *      theta0(14);
gamma_floodcat6_0   =  exp( theta0(10) ) *      theta0(15);
rho_star_0          =                           theta0(16);

G_spill             =  exp( theta_spill(10) ) * exp( theta_spill( 1) );
M_spill             =                         ( exp(-theta_spill( 2)) + 1 )^(-1);
V_spill             =                           exp( theta_spill( 3) );

% obtain shocks;
eta_0 = sigmaeta_0 * (            e0.*(tweek_sigma*ones(1,size(e0,2))) );
b_0   = sigmab_0   *  e1;
BC_0  = 0 + (u2 < normcdf(rho_star_0 +(tweek_rho  *ones(1,size(u2,2))),riskscore,85));


% compute time-invarient exogenous attachment;
z_gamma_0 = + gamma_floodcat1_0  .* floodcat1(:,1) ...
            + gamma_floodcat3_0  .* floodcat3(:,1) ...
            + gamma_floodcat4_0  .* floodcat4(:,1) ...
            + gamma_floodcat5_0  .* floodcat5(:,1) ...
            + gamma_floodcat6_0  .* floodcat6(:,1) ...
            ;

% create 4d and 2d index grids
[grid_j  ,grid_i  ,grid_t_star,grid_N_star_T  ] = ndgrid( 1:size(e0,1) , 1:50 , 1:6 , 0:50 );
[grid2d_j,grid2d_i                            ] = ndgrid( 1:size(e0,1) , 1:50              );
[grid2d_j,                     grid2d_N_star_T] = ndgrid( 1:size(e0,1) ,              0:50 );


DiscountAfterRebuild  =  (grid_t_star< 6) .* beta.^(grid_t_star) .* (1-beta.^(9-grid_t_star) ) ./ (1-beta);

[grid_BC_0] = ndgrid( BC_0 , 1:6 , 1:51);
 grid_BC_0  = reshape(grid_BC_0,[size(e0,1),50,6,51]);

[grid_eta_0] = ndgrid( eta_0 , 1:6 , 1:51);
 grid_eta_0  = reshape(grid_eta_0,[size(e0,1),50,6,51]);


Y0_expand = ndgrid(Y0,0:50);
Y0_expand = reshape(Y0_expand,[size(e0,1),50,1,51]);

V_C_NC_all(isnan(V_C_NC_all)) = -inf;
V_C_all(isnan(V_C_all)) = -inf;

%%%% NOTE: random components centered around theta0, spillover function defined by theta_spill
PAYOFFs =      grid_BC_0  .* V_C_all                                                                             ...
          + (1-grid_BC_0) .* V_C_NC_all                                                                          ...
          + DiscountAfterRebuild  .* z_gamma_0(grid_j)                                                           ...
          + DiscountAfterRebuild  .* G_spill .* betacdf(min(grid_N_star_T,I(grid_j))./I(grid_j),M_spill*V_spill,V_spill-M_spill*V_spill) ...
          + DiscountAfterRebuild  .* b_0(grid_j)                                                                 ...
          + DiscountAfterRebuild  .* grid_eta_0                                                                  ...
          + (grid_t_star<=1) .* delta1_0 .* beta.^1              ...
          + (grid_t_star<=2) .* delta2_0 .* beta.^2              ...
          + (grid_t_star<=3) .* delta3_0 .* beta.^3              ...
          + (grid_t_star<=4) .* delta4_0 .* beta.^4              ...
          + (grid_t_star<=5) .* delta5_0 .* beta.^5 .* (1-beta^(9-5)) ./ (1-beta)  ...
          ;
PAYOFFs(grid_i        > I(grid_j)) = 0;
PAYOFFs(grid_N_star_T > I(grid_j)) = 0;
[BESTPAYOFF, tstar] = max(PAYOFFs,[],3);
REBUILD_T = tstar<=5;
REBUILD_T(Y0_expand==1) = 1;
REBUILD_T(grid_i(:,:,1,:)>I(grid_j(:,:,1,:))) = 0;
REBUILD_T(grid_N_star_T(:,:,1,:)>I(grid_j(:,:,1,:))) = 0;
EQUILIBRIUM_T = squeeze((sum(REBUILD_T,2))==grid_N_star_T(:,1,1,:));

TOTWELFARE_T  = squeeze(sum(BESTPAYOFF,2)).*EQUILIBRIUM_T;
[TOT_V_STAR_T, N_STAR_T_plus1] = max(TOTWELFARE_T,[],2);
N_STAR_T = N_STAR_T_plus1 - 1;



%%%%%% POPULATE Y_model(:,:,T) %%%%%%
Y_model_array(:,:, 5) = squeeze( sum( mean((N_STAR_T(grid_j)==grid_N_star_T),3) .* REBUILD_T , 4) );

%Y_model_T_expand = ndgrid( squeeze(Y_model_array(:,:,5)) , 1:6 , 0:50 );
%Y_model_T_expand = reshape( Y_model_T_expand , [size(e0,1),50,6,51] );

TEMP = V_C_NC_all.*(grid_N_star_T==N_STAR_T(grid_j));
TEMP(isnan(TEMP)) = 0;
 EQM_V_C_NC_all_3d  = squeeze(sum(TEMP,4));
[EQM_V_C_NC_all]    = ndgrid( EQM_V_C_NC_all_3d , 1:51);
 EQM_V_C_NC_all     = reshape(EQM_V_C_NC_all ,[size(e0,1),50,6,51]);
 EQM_V_C_NC_all(        isnan(EQM_V_C_NC_all)) = -inf;
 EQM_V_C_NC_all(grid_i        > I(grid_j)) = -999;
 EQM_V_C_NC_all(grid_N_star_T > I(grid_j)) = -999;

TEMP = V_C_all   .*(grid_N_star_T==N_STAR_T(grid_j));
TEMP(isnan(TEMP)) = 0;
 EQM_V_C_all_3d  = squeeze(sum(TEMP,4));
[EQM_V_C_all   ] = ndgrid( EQM_V_C_all_3d , 1:51);
 EQM_V_C_all     = reshape(EQM_V_C_all    ,[size(e0,1),50,6,51]);
 EQM_V_C_all(        isnan(EQM_V_C_all)) = -inf;
 EQM_V_C_all(grid_i        > I(grid_j)) = -999;
 EQM_V_C_all(grid_N_star_T > I(grid_j)) = -999;

EQM_PAYOFFs =  grid_BC_0  .* EQM_V_C_all                                                                                                 ...
          + (1-grid_BC_0) .* EQM_V_C_NC_all                                                                                              ...
          + DiscountAfterRebuild  .* z_gamma_0(grid_j)                                                                                   ...
          + DiscountAfterRebuild  .* G_spill .* betacdf(min(grid_N_star_T,I(grid_j))./I(grid_j),M_spill*V_spill,V_spill-M_spill*V_spill) ...
          + DiscountAfterRebuild  .* b_0(grid_j)                                                                                         ...
          + DiscountAfterRebuild  .* grid_eta_0                                                                                          ...
          + (grid_t_star<=1) .* delta1_0 .* beta.^1                                                                                      ...
          + (grid_t_star<=2) .* delta2_0 .* beta.^2                                                                                      ...
          + (grid_t_star<=3) .* delta3_0 .* beta.^3                                                                                      ...
          + (grid_t_star<=4) .* delta4_0 .* beta.^4                                                                                      ...
          + (grid_t_star<=5) .* delta5_0 .* beta.^5 .* (1-beta^(9-5)) ./ (1-beta)                                                        ...
          ;

EQM_PAYOFFs(grid_i        >        I(grid_j)) = -inf;
EQM_PAYOFFs(grid_N_star_T >        I(grid_j)) = -inf;
EQM_PAYOFFs(grid_N_star_T > N_STAR_T(grid_j)) = -inf;
[BESTPAYOFF, tstar] = max(EQM_PAYOFFs,[],3);

for tt=4:-1:1;

    REBUILD_t = tstar<=tt;
    REBUILD_t(Y0_expand==1) = 1;
    REBUILD_t(grid_i(:,:,1,:)       >I(       grid_j(:,:,1,:))) = 0;
    REBUILD_t(grid_N_star_T(:,:,1,:)>I(       grid_j(:,:,1,:))) = 0;
    REBUILD_t(grid_N_star_T(:,:,1,:)>N_STAR_T(grid_j(:,:,1,:))) = 0;
    EQUILIBRIUM_t = squeeze((sum(REBUILD_t,2))==grid_N_star_T(:,1,1,:));
    N_STAR_t = max( EQUILIBRIUM_t .* grid2d_N_star_T ,[],2);
    Y_model_array(:,:,tt) = squeeze( sum( mean((N_STAR_t(grid_j)==grid_N_star_T),3) .* REBUILD_t , 4) );
end;



N5_star_Model_array = sum(Y_model_array(:,:,5),2);
MU5_loo_Model_array = ( ones(size(Y0,1),1)*(1:50) <= I*ones(1,50) ) .*   (N5_star_Model_array*ones(1,50) - Y_model_array(:,:,5)) ./ (I*ones(1,50)-1);
tt = 1;
for tt=1:5;
    rs_Y_model(:,tt)  = reshape( Y_model_array(:,:,tt) , size(Y0,1)*size(Y0,2) , 1 );
end;
households = reshape( ones(size(Y0,1),1)*(1:50) <= I*ones(1,50),size(Y0,1)*size(Y0,2),1);


MU_STAR = squeeze(sum(Y_model_array,2)) ./ (I*ones(1,5));

drop_4OLS                     =  reshape((Y0==1),size(Y0,1)*size(Y0,2),1) + (households==0) > 0;
drop_4RD                      =  reshape((Y0==1)|(NEVATRISK_opt2==1)|(RUNNING<.33)|(RUNNING>.67),size(Y0,1)*size(Y0,2),1) + (households==0) > 0;
drop_4closeRD                 =  reshape((Y0==1)|(NEVATRISK_opt2==1)|(RUNNING<.46)|(RUNNING>.56),size(Y0,1)*size(Y0,2),1) + (households==0) > 0;
drop_nonHHs                   =  (households==0);

Y_model_4OLS                  =  rs_Y_model;
Y_model_4OLS(drop_4OLS,:)     = [];

Y5_model                           =  squeeze(Y_model_array(:,:,5));
MU5_loo_model_4RD                  =  reshape((sum(Y5_model,2)*ones(1,50) - Y5_model)./((I-1)*ones(1,50)),size(Y0,1)*size(Y0,2),1);
MU5_loo_model_4RD(drop_4closeRD,:) = [];

Y5_model_4RD                       =  rs_Y_model(:,5) ;
Y5_model_4RD(drop_4closeRD,:)      = [];

% Export mergable simulation results
[jjj,iii] = ndgrid( 1:size(e0,1) , 1:50 );
rs_jjj  = reshape( jjj , size(Y0,1)*size(Y0,2) , 1 );
rs_iii  = reshape( iii , size(Y0,1)*size(Y0,2) , 1 );
SimOutput                            = [rs_jjj,rs_iii,rs_Y_model];
SimOutput(drop_nonHHs,:)             = [];

rs_BC   = reshape( BC_0                   , size(e0,1)*size(e0,2) , 1 );
rs_eta  = reshape( eta_0                  , size(e0,1)*size(e0,2) , 1 );
rs_b    = reshape( b_0*ones(1,size(e0,2)) , size(e0,1)*size(e0,2) , 1 );
Unobservables                        = [rs_jjj,rs_iii,rs_BC,rs_eta,rs_b];
Unobservables(drop_nonHHs,:)         = [];

rs_EQM_V_C_NC_all_3d                 = reshape( EQM_V_C_NC_all_3d , size(EQM_V_C_NC_all_3d,1)*size(EQM_V_C_NC_all_3d,2) , 6 );
rs_EQM_V_C_all_3d                    = reshape( EQM_V_C_all_3d    , size(EQM_V_C_all_3d   ,1)*size(EQM_V_C_all_3d   ,2) , 6 );
VC_NC_STAR                           = [rs_jjj,rs_iii,rs_EQM_V_C_NC_all_3d];
VC_NC_STAR(drop_nonHHs,:)            = [];
VC_STAR                              = [rs_jjj,rs_iii,rs_EQM_V_C_all_3d];
VC_STAR(drop_nonHHs,:)               = [];


