function [imp_wgts] = B3a_ComputeImpWeights(I,theta0,theta_spill,theta1,majblack,majcoll,floodcat1,floodcat2,floodcat3,floodcat4,floodcat5,floodcat6,riskscore,   e0,e1,u2,tweek_sigma,tweek_rho,MU_STAR)

% theta0 and theta1 parameter values;
G_0                 =  exp( theta0(10) ) * exp( theta0( 1) );
M_0                 =                    ( exp(-theta0( 2)) + 1 )^(-1);
V_0                 =                      exp( theta0( 3) );
delta1_0            =  exp( theta0(10) ) *      theta0( 4)  ;
delta2_0            =  exp( theta0(10) ) *      theta0( 5)  ;
delta3_0            =  exp( theta0(10) ) *      theta0( 6)  ;
delta4_0            =  exp( theta0(10) ) *      theta0( 7)  ;
delta5_0            =  exp( theta0(10) ) *      theta0( 8)  ;
sigmab_0            =  exp( theta0(10) ) * exp( theta0( 9) );
sigmaeta_0          =  exp( theta0(10) );
gamma_floodcat1_0   =  exp( theta0(10) ) *      theta0(11);
gamma_floodcat3_0   =  exp( theta0(10) ) *      theta0(12 );
gamma_floodcat4_0   =  exp( theta0(10) ) *      theta0(13);
gamma_floodcat5_0   =  exp( theta0(10) ) *      theta0(14);
gamma_floodcat6_0   =  exp( theta0(10) ) *      theta0(15);
rho_star_0          =                           theta0(16);


G_spill             =  exp( theta_spill(10) ) * exp( theta_spill( 1) );
M_spill             =                         ( exp(-theta_spill( 2)) + 1 )^(-1);
V_spill             =                           exp( theta_spill( 3) );


G_1                 =  exp( theta1(10) ) * exp( theta1( 1) );
M_1                 =                    ( exp(-theta1( 2)) + 1 )^(-1);
V_1                 =                      exp( theta1( 3) );
delta1_1            =  exp( theta1(10) ) *      theta1( 4)  ;
delta2_1            =  exp( theta1(10) ) *      theta1( 5)  ;
delta3_1            =  exp( theta1(10) ) *      theta1( 6)  ;
delta4_1            =  exp( theta1(10) ) *      theta1( 7)  ;
delta5_1            =  exp( theta1(10) ) *      theta1( 8)  ;
sigmab_1            =  exp( theta1(10) ) * exp( theta1( 9) );
sigmaeta_1          =  exp( theta1(10) );
gamma_floodcat1_1   =  exp( theta1(10) ) *      theta1(11);
gamma_floodcat3_1   =  exp( theta1(10) ) *      theta1(12 );
gamma_floodcat4_1   =  exp( theta1(10) ) *      theta1(13);
gamma_floodcat5_1   =  exp( theta1(10) ) *      theta1(14);
gamma_floodcat6_1   =  exp( theta1(10) ) *      theta1(15);
rho_star_1          =                           theta1(16);

% random components under theta0 and theta1;
eta_0   = sigmaeta_0 * (e0.*(tweek_sigma*ones(1,size(e0,2))) );
b_0     = sigmab_0   *  e1;
BC_0    = 0 + (u2 < normcdf(rho_star_0,riskscore,85));
Pr_BC_0 =         normcdf(rho_star_0 +(tweek_rho  *ones(1,size(u2,2))),riskscore,85);

b_1     = sigmab_1   * e1;
Pr_BC_1 = normcdf(rho_star_1,riskscore,85);


% time-invarient exogenous attachment under theta0 and theta1;
z_gamma_0 =   gamma_floodcat1_0  .* floodcat1(:,1) ...
            + gamma_floodcat3_0  .* floodcat3(:,1) ...
            + gamma_floodcat4_0  .* floodcat4(:,1) ...
            + gamma_floodcat5_0  .* floodcat5(:,1) ...
            + gamma_floodcat6_0  .* floodcat6(:,1) ...
            ;

z_gamma_1 =   gamma_floodcat1_1  .* floodcat1(:,1) ...
            + gamma_floodcat3_1  .* floodcat3(:,1) ...
            + gamma_floodcat4_1  .* floodcat4(:,1) ...
            + gamma_floodcat5_1  .* floodcat5(:,1) ...
            + gamma_floodcat6_1  .* floodcat6(:,1) ...
            ;

% theta0-predicted mu;
g_0 = G_spill*betacdf(MU_STAR,M_spill*V_spill,V_spill-M_spill*V_spill);
g_1 = G_1    *betacdf(MU_STAR,M_1    *V_1    ,V_1    -M_1    *V_1    );

% Create the "eta" that rationalizes the observed V_private under the theta_1 parameterization;
for t=1:5;
    eta_1(:,:,t) = eta_0                             + ...
                 ( z_gamma_0       - z_gamma_1       + ...
                   b_0             - b_1             + ...
                   g_0(:,t)        - g_1(:,t)        + ...
                   delta1_0*(t>=1) - delta1_1*(t>=1) + ...
                   delta2_0*(t>=2) - delta2_1*(t>=2) + ...
                   delta3_0*(t>=3) - delta3_1*(t>=3) + ...
                   delta4_0*(t>=4) - delta4_1*(t>=4) + ...
                   delta5_0*(t>=5) - delta5_1*(t>=5)   ...
                   ) * ones(1,50);
end;


% Compute weights;
[grid2d_j,grid2d_i] = ndgrid( (1:size(e0,1))' , 1:50 );

for tt=1:5;
logwgts0(:,tt) = sum(  log(  normpdf(eta_1(:,:,tt),0,sigmaeta_1) ./ normpdf(eta_0,0, sigmaeta_0*tweek_sigma*ones(1,size(e0,2))  )  )  .*  ( grid2d_i <= ( I*ones(1,50) ) ) , 2 );
end;
logwgts1       =       log(  normpdf(  b_1,0,sigmab_1  ) ./ normpdf(  b_0        ,0,sigmab_0               )  )                                            ;
logwgts2       = sum(  log(  ((1-Pr_BC_1)./(1-Pr_BC_0)).*(1-BC_0) + (Pr_BC_1./Pr_BC_0).*BC_0                  )  .*  ( grid2d_i <= ( I*ones(1,50) ) ) , 2 );

for tt=1:5;
imp_wgts(:,tt) = exp( logwgts0(:,tt) + logwgts1 + logwgts2 );
end;



