clear
clear mata
clear matrix
set mem 200m
set more off
set maxvar 10000

local simsdir  ""      /* Location of Simulation Output */



local replications = 80

****
**** cf_policy==1 ; baseline (RH)
**** cf_policy==2 ; noRH
**** cf_policy==3 ; Unconditional_RoadHome
****


adopath + /home/j/jmgregory/ado/
adopath




************************
*** 10 % sample runs ***
************************
use "`simsdir'SimOutputFile_MinMax_1_Sims_w_Covars.dta"

ren y1     pol1_y1
ren y2     pol1_y2
ren y3     pol1_y3
ren y4     pol1_y4
ren y5     pol1_y5
ren vc_nc1 pol1_vc_nc1
ren vc_nc2 pol1_vc_nc2
ren vc_nc3 pol1_vc_nc3
ren vc_nc4 pol1_vc_nc4
ren vc_nc5 pol1_vc_nc5
ren vc_nc6 pol1_vc_nc6
ren vc1    pol1_vc1
ren vc2    pol1_vc2
ren vc3    pol1_vc3
ren vc4    pol1_vc4
ren vc5    pol1_vc5
ren vc6    pol1_vc6

ren y1_min     minpol1_y1
ren y2_min     minpol1_y2
ren y3_min     minpol1_y3
ren y4_min     minpol1_y4
ren y5_min     minpol1_y5
ren vc_nc1_min minpol1_vc_nc1
ren vc_nc2_min minpol1_vc_nc2
ren vc_nc3_min minpol1_vc_nc3
ren vc_nc4_min minpol1_vc_nc4
ren vc_nc5_min minpol1_vc_nc5
ren vc_nc6_min minpol1_vc_nc6
ren vc1_min    minpol1_vc1
ren vc2_min    minpol1_vc2
ren vc3_min    minpol1_vc3
ren vc4_min    minpol1_vc4
ren vc5_min    minpol1_vc5
ren vc6_min    minpol1_vc6

joinby i j rep using "`simsdir'SimOutputFile_MinMax_2_Sims_w_Covars.dta", unmatched(both)
tab _m
drop _m

ren y1     pol2_y1
ren y2     pol2_y2
ren y3     pol2_y3
ren y4     pol2_y4
ren y5     pol2_y5
ren vc_nc1 pol2_vc_nc1
ren vc_nc2 pol2_vc_nc2
ren vc_nc3 pol2_vc_nc3
ren vc_nc4 pol2_vc_nc4
ren vc_nc5 pol2_vc_nc5
ren vc_nc6 pol2_vc_nc6
ren vc1    pol2_vc1
ren vc2    pol2_vc2
ren vc3    pol2_vc3
ren vc4    pol2_vc4
ren vc5    pol2_vc5
ren vc6    pol2_vc6

ren y1_min     minpol2_y1
ren y2_min     minpol2_y2
ren y3_min     minpol2_y3
ren y4_min     minpol2_y4
ren y5_min     minpol2_y5
ren vc_nc1_min minpol2_vc_nc1
ren vc_nc2_min minpol2_vc_nc2
ren vc_nc3_min minpol2_vc_nc3
ren vc_nc4_min minpol2_vc_nc4
ren vc_nc5_min minpol2_vc_nc5
ren vc_nc6_min minpol2_vc_nc6
ren vc1_min    minpol2_vc1
ren vc2_min    minpol2_vc2
ren vc3_min    minpol2_vc3
ren vc4_min    minpol2_vc4
ren vc5_min    minpol2_vc5
ren vc6_min    minpol2_vc6

joinby i j rep using "`simsdir'SimOutputFile3_Sims_w_Covars.dta", unmatched(both)
tab _m
drop _m

ren y1     pol3_y1
ren y2     pol3_y2
ren y3     pol3_y3
ren y4     pol3_y4
ren y5     pol3_y5
ren vc_nc1 pol3_vc_nc1
ren vc_nc2 pol3_vc_nc2
ren vc_nc3 pol3_vc_nc3
ren vc_nc4 pol3_vc_nc4
ren vc_nc5 pol3_vc_nc5
ren vc_nc6 pol3_vc_nc6
ren vc1    pol3_vc1
ren vc2    pol3_vc2
ren vc3    pol3_vc3
ren vc4    pol3_vc4
ren vc5    pol3_vc5
ren vc6    pol3_vc6

save "`simsdir'SimOutputFile_all_Sims_w_Covars_SelectMinEqm.dta", replace
keep if rep==1
save "`simsdir'SimOutputFile_all_Sims_w_Covars_SelectMinEqm_10pct.dta", replace
clear


 use    i j rep pol7_y* using "`simsdir'SimOutputFile_all_Sims_w_Covars.dta"
 joinby i j rep         using "`simsdir'SimOutputFile_all_Sims_w_Covars_SelectMinEqm.dta"



su majblack majcoll RISKCAT1-RISKCAT7

***************
*** Recodes ***
***************
local beta       = .95
local r          = 1/`beta' - 1

local Byear1     = -1.1221
local Byear2     = -0.7790
local Byear3     = -0.3065
local Byear4     =  0.0159
local Byear5     =  0.2028

local Bfloodcat1 = -1.0159
local Bfloodcat3 = -0.6856
local Bfloodcat4 = -0.0519
local Bfloodcat5 = -1.2209
local Bfloodcat6 = -1.1393

local G          =  0.2642
local M          =  0.7839
local V          =  3.6853

local G_star     =  0.43
local M_star     =  0.82
local V_star     =  6.99


gen Zgamma =   floodcat1 * `Bfloodcat1' /*
*/           + floodcat3 * `Bfloodcat3' /*
*/           + floodcat4 * `Bfloodcat4' /*
*/           + floodcat5 * `Bfloodcat5' /*
*/           + floodcat6 * `Bfloodcat6'



*"spread" weights (populated for p==1) across all policies
forval tt=1/5 {
   egen aux = mean(wgt`tt'), by(j rep)
   replace wgt`tt'=aux
   drop aux
}

*Identify block-replications where "tipping" may occur
forval pp=1/2 {
   forval tt=1/5 {
      di `tt'
      egen pol`pp'_mumax`tt' = mean(pol`pp'_y`tt'), by(j rep)
   }
   forval tt=1/5 {
      di `tt'
      egen pol`pp'_mumin`tt' = mean(minpol`pp'_y`tt'), by(j rep)
   }
}
gen tipping = (pol1_mumax5!=pol1_mumin5) * (pol2_mumax5==pol2_mumin5) * (pol1_mumin5>pol2_mumax5)


*Count equilibria by policy
forval pp=1/2 {
   gen multeqm`pp' = pol`pp'_mumax5!=pol`pp'_mumin5
}


**** 
**** 
**** POLICIES:
**** 
**** cf_policy==1 ; baseline (RH)
**** cf_policy==2 ; noRH
****




gen     floodcat = .
replace floodcat = 1 if floodcat1==1
replace floodcat = 2 if floodcat2==1
replace floodcat = 3 if floodcat3==1
replace floodcat = 4 if floodcat4==1
replace floodcat = 5 if floodcat5==1
replace floodcat = 6 if floodcat6==1
gen     RISKCAT = .
replace RISKCAT = 1 if RISKCAT1==1
replace RISKCAT = 2 if RISKCAT2==1
replace RISKCAT = 3 if RISKCAT3==1
replace RISKCAT = 4 if RISKCAT4==1
replace RISKCAT = 5 if RISKCAT5==1
replace RISKCAT = 6 if RISKCAT6==1
replace RISKCAT = 7 if RISKCAT7==1

egen mu0 = mean(Y0), by(j rep)
cap drop pol*_mu*
forval pp = 1/3 {
if inlist(`pp',1,2,3,6,7)==1 | (`pp'>=100 & mod(`pp',2)==0) {
   forval tt=1/5 {
      di "p=`pp', t=`tt'"
      egen pol`pp'_mu`tt' = mean(pol`pp'_y`tt'), by(j rep)
   }
}
}
su pol*_mu5

***************************************
** 0. equilibrium home price impacts **
***************************************
forval pp = 1/3 {
if inlist(`pp',1,2,3,6,7)==1 | (`pp'>=100 & mod(`pp',2)==0) {
   cap drop pol`pp'_PRICE
   gen pol`pp'_PRICE = P_HAT_BASE * exp(   0.080 * max(0,min(.2,pol`pp'_mu5-.4))  /*
   */                                    + 0.222 * max(0,min(.2,pol`pp'_mu5-.6))  /*
   */                                    + 0.464 * max(0,min(.2,pol`pp'_mu5-.8)) )
}
}

forval pp = 1/3 {
if inlist(`pp',1,2,3,6,7)==1 | (`pp'>=100 & mod(`pp',2)==0) {
   gen     Dprice`pp' = pol`pp'_PRICE - pol3_PRICE
}
}


***************************************
** 1. equilibrium grant expenditures **
***************************************
gen pol1_GrantExpend = (pol1_y5>Y0)*grant1   +   (pol1_y5==0)*(grant2>pol1_PRICE-k)*(grant2)
gen pol2_GrantExpend = 0
gen pol3_GrantExpend = (Y0==0)*grant1
/*
forval pp = 100(2)200 {
   gen pol`pp'_GrantExpend = (pol`pp'_y5>Y0)*grant1   +   (pol`pp'_y5==0)*(1 - (`pp'-100)/100 )*grant1
}
*/
forval pp = 1/3 {
if inlist(`pp',1,2,3    )==1 | (`pp'>=100 & mod(`pp',2)==0) {
   gen DGrantExpend`pp' = `beta'^3 * ( pol`pp'_GrantExpend - pol3_GrantExpend )
}
}


**********************************************************
** 2. equivalent variations for amenity utility changes **
**********************************************************
foreach var of varlist pol*_vc* {
   su `var'
   if r(N)==0 {
      ren     `var' aux
      gen     `var' = real(aux)
      drop aux
   }
}
forval pp = 1/3 {
if inlist(`pp',1,2,3,6,7)==1 | (`pp'>=100 & mod(`pp',2)==0) {
   cap drop pol`pp'_vc
   gen      pol`pp'_vc = .
   replace  pol`pp'_vc = pol`pp'_vc_nc6 if pol`pp'_y5==0 & bc==0
   replace  pol`pp'_vc = pol`pp'_vc_nc5 if pol`pp'_y5==1 & bc==0
   replace  pol`pp'_vc = pol`pp'_vc_nc4 if pol`pp'_y4==1 & bc==0
   replace  pol`pp'_vc = pol`pp'_vc_nc3 if pol`pp'_y3==1 & bc==0
   replace  pol`pp'_vc = pol`pp'_vc_nc2 if pol`pp'_y2==1 & bc==0
   replace  pol`pp'_vc = pol`pp'_vc_nc1 if pol`pp'_y1==1 & bc==0
   replace  pol`pp'_vc = pol`pp'_vc6    if pol`pp'_y5==0 & bc==1
   replace  pol`pp'_vc = pol`pp'_vc5    if pol`pp'_y5==1 & bc==1
   replace  pol`pp'_vc = pol`pp'_vc4    if pol`pp'_y4==1 & bc==1
   replace  pol`pp'_vc = pol`pp'_vc3    if pol`pp'_y3==1 & bc==1
   replace  pol`pp'_vc = pol`pp'_vc2    if pol`pp'_y2==1 & bc==1
   replace  pol`pp'_vc = pol`pp'_vc1    if pol`pp'_y1==1 & bc==1
   drop     pol`pp'_vc_nc1-pol`pp'_vc_nc6 pol`pp'_vc1-pol`pp'_vc6
   gen      pol`pp'_c_tilde = exp( pol`pp'_vc * (1-`beta') / `beta' / (1-`beta'^8) )
}
}

forval pp = 1/3 {
if inlist(`pp',1,2,3,6,7)==1 | (`pp'>=100 & mod(`pp',2)==0) {
   gen Dvc`pp' = pol`pp'_vc - pol3_vc
}
}


/*
EQM_PAYOFFs =  grid_BC_0  .* EQM_V_C_all                                                                                                 ...
          + (1-grid_BC_0) .* EQM_V_C_NC_all                                                                                              ...
          + DiscountAfterRebuild  .* z_gamma_0(grid_j)                                                                                   ...
          + DiscountAfterRebuild  .* G_spill .* betacdf(min(grid_N_star_T,I(grid_j))./I(grid_j),M_spill*V_spill,V_spill-M_spill*V_spill) ...
          + DiscountAfterRebuild  .* b_0(grid_j)                                                                                         ...
          + DiscountAfterRebuild  .* grid_eta_0                                                                                          ...
          + (grid_t_star<=1) .* delta1_0 .* beta.^1                                                                                      ...
          + (grid_t_star<=2) .* delta2_0 .* beta.^2                                                                                      ...
          + (grid_t_star<=3) .* delta3_0 .* beta.^3                                                                                      ...
          + (grid_t_star<=4) .* delta4_0 .* beta.^4                                                                                      ...
          + (grid_t_star<=5) .* delta5_0 .* beta.^5 .* (1-beta^(9-5)) ./ (1-beta)                                                        ...
          ;
*/

forval pp = 1/3 {
if inlist(`pp',1,2,3,6,7)==1 | (`pp'>=100 & mod(`pp',2)==0) {
   gen DUtil`pp' =   `beta'^1 * ( pol`pp'_y1 * ( `Byear1' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol`pp'_mu1)) - pol3_y1 * ( `Byear1' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol3_mu1)) ) /*
   */              + `beta'^2 * ( pol`pp'_y2 * ( `Byear2' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol`pp'_mu2)) - pol3_y2 * ( `Byear2' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol3_mu2)) ) /*
   */              + `beta'^3 * ( pol`pp'_y3 * ( `Byear3' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol`pp'_mu3)) - pol3_y3 * ( `Byear3' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol3_mu3)) ) /*
   */              + `beta'^4 * ( pol`pp'_y4 * ( `Byear4' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol`pp'_mu4)) - pol3_y4 * ( `Byear4' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol3_mu4)) ) /*
   */              + `beta'^5 * ( pol`pp'_y5 * ( `Byear5' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol`pp'_mu5)) - pol3_y5 * ( `Byear5' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol3_mu5)) ) /*
   */              + `beta'^6 * ( pol`pp'_y5 * ( `Byear5' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol`pp'_mu5)) - pol3_y5 * ( `Byear5' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol3_mu5)) ) /*
   */              + `beta'^7 * ( pol`pp'_y5 * ( `Byear5' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol`pp'_mu5)) - pol3_y5 * ( `Byear5' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol3_mu5)) ) /*
   */              + `beta'^8 * ( pol`pp'_y5 * ( `Byear5' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol`pp'_mu5)) - pol3_y5 * ( `Byear5' + Zgamma + eta + b + `G'*ibeta(`M'*`V',(1-`M')*`V',pol3_mu5)) )
}
}

forval pp = 1/3 {
if inlist(`pp',1,2,3,6,7)==1 | (`pp'>=100 & mod(`pp',2)==0) {
   gen DUtilTot`pp' = DUtil`pp' + Dvc`pp'
}
}


local beta = .95
forval pp = 1/3 {
if inlist(`pp',1,2,3,6,7)==1 | (`pp'>=100 & mod(`pp',2)==0) {
   gen     DU_ev`pp'   = 0
   replace DU_ev`pp'   = pol3_c_tilde * ( exp( (1-`beta')/`beta'/(1-`beta'^8) * DUtil`pp' ) - 1 ) * `beta' * (1-`beta'^8) / (1-`beta')
}
}


local beta = .95
forval pp = 1/3 {
if inlist(`pp',1,2,3,6,7)==1 | (`pp'>=100 & mod(`pp',2)==0) {
   gen     DUTot_ev`pp'   = 0
   replace DUTot_ev`pp'   = pol3_c_tilde * ( exp( (1-`beta')/`beta'/(1-`beta'^8) * DUtilTot`pp' ) - 1 ) * `beta' * (1-`beta'^8) / (1-`beta')
}
}

forval pp = 1/3 {
if inlist(`pp',1,2,3    )==1 | (`pp'>=100 & mod(`pp',2)==0) {
   cap drop DWelfare`pp'
   gen      DWelfare`pp' = 0
   replace  DWelfare`pp' = DUTot_ev`pp' - DGrantExpend`pp' if pol3_y5==1 | pol`pp'_y5==1
   replace  DWelfare`pp' = Dprice`pp'                      if pol3_y5==0 & pol`pp'_y5==0
}
}

gen aux = round(mu0-.05,.10)+.05
egen mu0_round10 = group( aux )
drop aux

gen aux = round(pol3_mu5-.05,.10)+.05
egen pol3_mu5_round10 = group( aux )
drop aux

tab pol3_mu5_round10, gen(BASEMU5_)

**********************
**** SAVE RECODED ****
**********************
save "`simsdir'TEMP.dta", replace
clear





use                 "`simsdir'TEMP.dta"

*****************************************************************************************************************
*** Differences in various traits and policy impacts for blocks with unique vs. multiple equilibria (TABLE 7) ***
*****************************************************************************************************************

*******************************************************************************************
*** 7.a. Descriptive Statistics by Block Equilibrium "Type" by unique eqm. vs. multiple ***
*******************************************************************************************
logout, save(ZZZ_T7a-DescriptiveStats_HH_FindingMultipleEquilibria.xls        ) excel replace: tabstat pctblack pctcoll floodcat* Y0         running_imp RISKCAT* Y1-Y5       BASEMU5_*                               [aw=wgt5], columns(statistics) stat(mean sd N)
logout, save(ZZZ_T7a-DescriptiveStats_HH_FindingMultipleEquilibria00.xls      ) excel replace: tabstat pctblack pctcoll floodcat* Y0         running_imp RISKCAT* Y1-Y5       BASEMU5_*    if multeqm2==0&multeqm1==0 [aw=wgt5], columns(statistics) stat(mean sd N)
logout, save(ZZZ_T7a-DescriptiveStats_HH_FindingMultipleEquilibria01.xls      ) excel replace: tabstat pctblack pctcoll floodcat* Y0         running_imp RISKCAT* Y1-Y5       BASEMU5_*    if multeqm2==0&multeqm1==1 [aw=wgt5], columns(statistics) stat(mean sd N)
logout, save(ZZZ_T7a-DescriptiveStats_HH_FindingMultipleEquilibria10.xls      ) excel replace: tabstat pctblack pctcoll floodcat* Y0         running_imp RISKCAT* Y1-Y5       BASEMU5_*    if multeqm2==1&multeqm1==0 [aw=wgt5], columns(statistics) stat(mean sd N)
logout, save(ZZZ_T7a-DescriptiveStats_HH_FindingMultipleEquilibria11.xls      ) excel replace: tabstat pctblack pctcoll floodcat* Y0         running_imp RISKCAT* Y1-Y5       BASEMU5_*    if multeqm2==1&multeqm1==1 [aw=wgt5], columns(statistics) stat(mean sd N)

***********************************************************************
*** 7.b Simmple Rebuilding Rate Impacts by unique eqm. vs. multiple ***
***********************************************************************
caplog using ZZZ-TAB7b_Rebuilding_Impacts_FindingMultipleEquilibria.log, replace: tabstat pol3_y5 pol1_y5 pol2_y5 pol7_y5 pol1_y5 Y5 [aw=wgt5], stat(mean)
caplog using ZZZ-TAB7b_Rebuilding_Impacts_FindingMultipleEquilibria.log, append : tabstat pol3_y5 pol1_y5 pol2_y5 pol7_y5 pol1_y5 Y5 if multeqm2==0&multeqm1==0 [aw=wgt5], stat(mean)
caplog using ZZZ-TAB7b_Rebuilding_Impacts_FindingMultipleEquilibria.log, append : tabstat pol3_y5 pol1_y5 pol2_y5 pol7_y5 pol1_y5 Y5 if multeqm2==0&multeqm1==1 [aw=wgt5], stat(mean)
caplog using ZZZ-TAB7b_Rebuilding_Impacts_FindingMultipleEquilibria.log, append : tabstat pol3_y5 pol1_y5 pol2_y5 pol7_y5 pol1_y5 Y5 if multeqm2==1&multeqm1==0 [aw=wgt5], stat(mean)
caplog using ZZZ-TAB7b_Rebuilding_Impacts_FindingMultipleEquilibria.log, append : tabstat pol3_y5 pol1_y5 pol2_y5 pol7_y5 pol1_y5 Y5 if multeqm2==1&multeqm1==1 [aw=wgt5], stat(mean)

cap gen wgt5_rnd = round(wgt5*100000)
caplog using ZZZ-TAB7b_Rebuilding_Impacts_FindingMultipleEquilibria.log, append : tab multeqm2 multeqm1 [aw=wgt5_rnd], nof cell

logout,  use(ZZZ-TAB7b_Rebuilding_Impacts_FindingMultipleEquilibria.log) save(ZZZ-TAB5_Rebuilding_Impacts_FindingMultipleEquilibria.xls) excel replace


***************************************************
*** 7.c. RH Welfare by unique eqm. vs. multiple ***
***************************************************
caplog using ZZZ-TAB7c_welfare_FindingMultipleEquilibria.log, replace: tabstat DWelfare1 Dprice1 DUTot_ev1 DGrantExpend1 [aw=wgt5], stat(sum mean)
caplog using ZZZ-TAB7c_welfare_FindingMultipleEquilibria.log, append : tabstat DWelfare1 Dprice1 DUTot_ev1 DGrantExpend1 if multeqm2==0&multeqm1==0 [aw=wgt5], stat(sum mean)
caplog using ZZZ-TAB7c_welfare_FindingMultipleEquilibria.log, append : tabstat DWelfare1 Dprice1 DUTot_ev1 DGrantExpend1 if multeqm2==0&multeqm1==1 [aw=wgt5], stat(sum mean)
caplog using ZZZ-TAB7c_welfare_FindingMultipleEquilibria.log, append : tabstat DWelfare1 Dprice1 DUTot_ev1 DGrantExpend1 if multeqm2==1&multeqm1==0 [aw=wgt5], stat(sum mean)
caplog using ZZZ-TAB7c_welfare_FindingMultipleEquilibria.log, append : tabstat DWelfare1 Dprice1 DUTot_ev1 DGrantExpend1 if multeqm2==1&multeqm1==1 [aw=wgt5], stat(sum mean)
logout,  use(ZZZ-TAB7c_welfare_FindingMultipleEquilibria.log) save(ZZZ-TAB6_welfare_FindingMultipleEquilibria.xls) excel replace






